Index: liveMedia/include/GenericMediaServer.hh
===================================================================
--- liveMedia/include/GenericMediaServer.hh	(revision 14473)
+++ liveMedia/include/GenericMediaServer.hh	(revision 14474)
@@ -1,192 +1,198 @@
-/**********
-This library is free software; you can redistribute it and/or modify it under
-the terms of the GNU Lesser General Public License as published by the
-Free Software Foundation; either version 2.1 of the License, or (at your
-option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)
-
-This library is distributed in the hope that it will be useful, but WITHOUT
-ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
-more details.
-
-You should have received a copy of the GNU Lesser General Public License
-along with this library; if not, write to the Free Software Foundation, Inc.,
-51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
-**********/
-// "liveMedia"
-// Copyright (c) 1996-2016 Live Networks, Inc.  All rights reserved.
-// A generic media server class, used to implement a RTSP server, and any other server that uses
-//  "ServerMediaSession" objects to describe media to be served.
-// C++ header
-
-#ifndef _GENERIC_MEDIA_SERVER_HH
-#define _GENERIC_MEDIA_SERVER_HH
-
-#ifndef _MEDIA_HH
-#include "Media.hh"
-#endif
-#ifndef _SERVER_MEDIA_SESSION_HH
-#include "ServerMediaSession.hh"
-#endif
-
-#ifndef REQUEST_BUFFER_SIZE
-#define REQUEST_BUFFER_SIZE 20000 // for incoming requests
-#endif
-#ifndef RESPONSE_BUFFER_SIZE
-#define RESPONSE_BUFFER_SIZE 20000
-#endif
-
-class GenericMediaServer: public Medium {
-public:
-  void addServerMediaSession(ServerMediaSession* serverMediaSession);
-
-  virtual ServerMediaSession*
-  lookupServerMediaSession(char const* streamName, Boolean isFirstLookupInSession = True);
-
-  void removeServerMediaSession(ServerMediaSession* serverMediaSession);
-      // Removes the "ServerMediaSession" object from our lookup table, so it will no longer be accessible by new clients.
-      // (However, any *existing* client sessions that use this "ServerMediaSession" object will continue streaming.
-      //  The "ServerMediaSession" object will not get deleted until all of these client sessions have closed.)
-      // (To both delete the "ServerMediaSession" object *and* close all client sessions that use it,
-      //  call "deleteServerMediaSession(serverMediaSession)" instead.)
-  void removeServerMediaSession(char const* streamName);
-     // ditto
-
-  void closeAllClientSessionsForServerMediaSession(ServerMediaSession* serverMediaSession);
-      // Closes (from the server) all client sessions that are currently using this "ServerMediaSession" object.
-      // Note, however, that the "ServerMediaSession" object remains accessible by new clients.
-  void closeAllClientSessionsForServerMediaSession(char const* streamName);
-     // ditto
-
-  void deleteServerMediaSession(ServerMediaSession* serverMediaSession);
-      // Equivalent to:
-      //     "closeAllClientSessionsForServerMediaSession(serverMediaSession); removeServerMediaSession(serverMediaSession);"
-  void deleteServerMediaSession(char const* streamName);
-      // Equivalent to:
-      //     "closeAllClientSessionsForServerMediaSession(streamName); removeServerMediaSession(streamName);
-
-protected:
-  GenericMediaServer(UsageEnvironment& env, int ourSocket, Port ourPort,
-		     unsigned reclamationSeconds);
-      // If "reclamationSeconds" > 0, then the "ClientSession" state for each client will get
-      // reclaimed if no activity from the client is detected in at least "reclamationSeconds".
-  // we're an abstract base class
-  virtual ~GenericMediaServer();
-  void cleanup(); // MUST be called in the destructor of any subclass of us
-
-  static int setUpOurSocket(UsageEnvironment& env, Port& ourPort);
-
-  static void incomingConnectionHandler(void*, int /*mask*/);
-  void incomingConnectionHandler();
-  void incomingConnectionHandlerOnSocket(int serverSocket);
-
-public: // should be protected, but some old compilers complain otherwise
-  // The state of a TCP connection used by a client:
-  class ClientConnection {
-  protected:
-    ClientConnection(GenericMediaServer& ourServer, int clientSocket, struct sockaddr_in clientAddr);
-    virtual ~ClientConnection();
-
-    UsageEnvironment& envir() { return fOurServer.envir(); }
-    void closeSockets();
-
-    static void incomingRequestHandler(void*, int /*mask*/);
-    void incomingRequestHandler();
-    virtual void handleRequestBytes(int newBytesRead) = 0;
-    void resetRequestBuffer();
-
-  protected:
-    friend class GenericMediaServer;
-    friend class ClientSession;
-    friend class RTSPServer; // needed to make some broken Windows compilers work; remove this in the future when we end support for Windows
-    GenericMediaServer& fOurServer;
-    int fOurSocket;
-    struct sockaddr_in fClientAddr;
-    unsigned char fRequestBuffer[REQUEST_BUFFER_SIZE];
-    unsigned char fResponseBuffer[RESPONSE_BUFFER_SIZE];
-    unsigned fRequestBytesAlreadySeen, fRequestBufferBytesLeft;
-  };
-
-  // The state of an individual client session (using one or more sequential TCP connections) handled by a server:
-  class ClientSession {
-  protected:
-    ClientSession(GenericMediaServer& ourServer, u_int32_t sessionId);
-    virtual ~ClientSession();
-
-    UsageEnvironment& envir() { return fOurServer.envir(); }
-    void noteLiveness();
-    static void noteClientLiveness(ClientSession* clientSession);
-    static void livenessTimeoutTask(ClientSession* clientSession);
-
-  protected:
-    friend class GenericMediaServer;
-    friend class ClientConnection;
-    GenericMediaServer& fOurServer;
-    u_int32_t fOurSessionId;
-    ServerMediaSession* fOurServerMediaSession;
-    TaskToken fLivenessCheckTask;
-  };
-
-protected:
-  virtual ClientConnection* createNewClientConnection(int clientSocket, struct sockaddr_in clientAddr) = 0;
-  virtual ClientSession* createNewClientSession(u_int32_t sessionId) = 0;
-
-  ClientSession* createNewClientSessionWithId();
-      // Generates a new (unused) random session id, and calls the "createNewClientSession()"
-      // virtual function with this session id as parameter.
-
-  // Lookup a "ClientSession" object by sessionId (integer, and string):
-  ClientSession* lookupClientSession(u_int32_t sessionId);
-  ClientSession* lookupClientSession(char const* sessionIdStr);
-
-  // An iterator over our "ServerMediaSession" objects:
-  class ServerMediaSessionIterator {
-  public:
-    ServerMediaSessionIterator(GenericMediaServer& server);
-    virtual ~ServerMediaSessionIterator();
-    ServerMediaSession* next();
-  private:
-    HashTable::Iterator* fOurIterator;
-  };
-
-protected:
-  friend class ClientConnection;
-  friend class ClientSession;	
-  friend class ServerMediaSessionIterator;
-  int fServerSocket;
-  Port fServerPort;
-  unsigned fReclamationSeconds;
-
-private:
-  HashTable* fServerMediaSessions; // maps 'stream name' strings to "ServerMediaSession" objects
-  HashTable* fClientConnections; // the "ClientConnection" objects that we're using
-  HashTable* fClientSessions; // maps 'session id' strings to "ClientSession" objects
-};
-
-// A data structure used for optional user/password authentication:
-
-class UserAuthenticationDatabase {
-public:
-  UserAuthenticationDatabase(char const* realm = NULL,
-			     Boolean passwordsAreMD5 = False);
-    // If "passwordsAreMD5" is True, then each password stored into, or removed from,
-    // the database is actually the value computed
-    // by md5(<username>:<realm>:<actual-password>)
-  virtual ~UserAuthenticationDatabase();
-
-  virtual void addUserRecord(char const* username, char const* password);
-  virtual void removeUserRecord(char const* username);
-
-  virtual char const* lookupPassword(char const* username);
-      // returns NULL if the user name was not present
-
-  char const* realm() { return fRealm; }
-  Boolean passwordsAreMD5() { return fPasswordsAreMD5; }
-
-protected:
-  HashTable* fTable;
-  char* fRealm;
-  Boolean fPasswordsAreMD5;
-};
-
-#endif
+/**********
+This library is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the
+Free Software Foundation; either version 2.1 of the License, or (at your
+option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)
+
+This library is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
+more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this library; if not, write to the Free Software Foundation, Inc.,
+51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
+**********/
+// "liveMedia"
+// Copyright (c) 1996-2016 Live Networks, Inc.  All rights reserved.
+// A generic media server class, used to implement a RTSP server, and any other server that uses
+//  "ServerMediaSession" objects to describe media to be served.
+// C++ header
+
+#ifndef _GENERIC_MEDIA_SERVER_HH
+#define _GENERIC_MEDIA_SERVER_HH
+
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
+#ifndef _MEDIA_HH
+#include "Media.hh"
+#endif
+#ifndef _SERVER_MEDIA_SESSION_HH
+#include "ServerMediaSession.hh"
+#endif
+
+#ifndef REQUEST_BUFFER_SIZE
+#define REQUEST_BUFFER_SIZE 20000 // for incoming requests
+#endif
+#ifndef RESPONSE_BUFFER_SIZE
+#define RESPONSE_BUFFER_SIZE 20000
+#endif
+
+class LIVEMEDIALIB_API GenericMediaServer: public Medium {
+public:
+  void addServerMediaSession(ServerMediaSession* serverMediaSession);
+
+  virtual ServerMediaSession*
+  lookupServerMediaSession(char const* streamName, char const* streamParams, Boolean isFirstLookupInSession = True);
+
+  void removeServerMediaSession(ServerMediaSession* serverMediaSession);
+      // Removes the "ServerMediaSession" object from our lookup table, so it will no longer be accessible by new clients.
+      // (However, any *existing* client sessions that use this "ServerMediaSession" object will continue streaming.
+      //  The "ServerMediaSession" object will not get deleted until all of these client sessions have closed.)
+      // (To both delete the "ServerMediaSession" object *and* close all client sessions that use it,
+      //  call "deleteServerMediaSession(serverMediaSession)" instead.)
+  void removeServerMediaSession(char const* streamName);
+     // ditto
+
+  void closeAllClientSessionsForServerMediaSession(ServerMediaSession* serverMediaSession);
+      // Closes (from the server) all client sessions that are currently using this "ServerMediaSession" object.
+      // Note, however, that the "ServerMediaSession" object remains accessible by new clients.
+  void closeAllClientSessionsForServerMediaSession(char const* streamName);
+     // ditto
+
+  void deleteServerMediaSession(ServerMediaSession* serverMediaSession);
+      // Equivalent to:
+      //     "closeAllClientSessionsForServerMediaSession(serverMediaSession); removeServerMediaSession(serverMediaSession);"
+  void deleteServerMediaSession(char const* streamName);
+      // Equivalent to:
+      //     "closeAllClientSessionsForServerMediaSession(streamName); removeServerMediaSession(streamName);
+
+protected:
+  GenericMediaServer(UsageEnvironment& env, int ourSocket, Port ourPort,
+		     unsigned reclamationSeconds);
+      // If "reclamationSeconds" > 0, then the "ClientSession" state for each client will get
+      // reclaimed if no activity from the client is detected in at least "reclamationSeconds".
+  // we're an abstract base class
+  virtual ~GenericMediaServer();
+  void cleanup(); // MUST be called in the destructor of any subclass of us
+
+  static int setUpOurSocket(UsageEnvironment& env, Port& ourPort);
+
+  static void incomingConnectionHandler(void*, int /*mask*/);
+  void incomingConnectionHandler();
+  void incomingConnectionHandlerOnSocket(int serverSocket);
+
+public: // should be protected, but some old compilers complain otherwise
+  // The state of a TCP connection used by a client:
+  class ClientConnection {
+  protected:
+    ClientConnection(GenericMediaServer& ourServer, int clientSocket, struct sockaddr_in clientAddr);
+    virtual ~ClientConnection();
+
+    UsageEnvironment& envir() { return fOurServer.envir(); }
+    void closeSockets();
+
+    static void incomingRequestHandler(void*, int /*mask*/);
+    void incomingRequestHandler();
+    virtual void handleRequestBytes(int newBytesRead) = 0;
+    void resetRequestBuffer();
+
+  protected:
+    friend class GenericMediaServer;
+    friend class ClientSession;
+    friend class RTSPServer; // needed to make some broken Windows compilers work; remove this in the future when we end support for Windows
+    GenericMediaServer& fOurServer;
+    int fOurSocket;
+    struct sockaddr_in fClientAddr;
+    unsigned char fRequestBuffer[REQUEST_BUFFER_SIZE];
+    unsigned char fResponseBuffer[RESPONSE_BUFFER_SIZE];
+    unsigned fRequestBytesAlreadySeen, fRequestBufferBytesLeft;
+  };
+
+  // The state of an individual client session (using one or more sequential TCP connections) handled by a server:
+  class ClientSession {
+  protected:
+    ClientSession(GenericMediaServer& ourServer, u_int32_t sessionId);
+    virtual ~ClientSession();
+
+    UsageEnvironment& envir() { return fOurServer.envir(); }
+    void noteLiveness();
+    static void noteClientLiveness(ClientSession* clientSession);
+    static void livenessTimeoutTask(ClientSession* clientSession);
+
+  protected:
+    friend class GenericMediaServer;
+    friend class ClientConnection;
+    GenericMediaServer& fOurServer;
+    u_int32_t fOurSessionId;
+    ServerMediaSession* fOurServerMediaSession;
+    TaskToken fLivenessCheckTask;
+  };
+
+protected:
+  virtual ClientConnection* createNewClientConnection(int clientSocket, struct sockaddr_in clientAddr) = 0;
+  virtual ClientSession* createNewClientSession(u_int32_t sessionId) = 0;
+
+  ClientSession* createNewClientSessionWithId();
+      // Generates a new (unused) random session id, and calls the "createNewClientSession()"
+      // virtual function with this session id as parameter.
+
+  // Lookup a "ClientSession" object by sessionId (integer, and string):
+  ClientSession* lookupClientSession(u_int32_t sessionId);
+  ClientSession* lookupClientSession(char const* sessionIdStr);
+
+  // An iterator over our "ServerMediaSession" objects:
+  class ServerMediaSessionIterator {
+  public:
+    ServerMediaSessionIterator(GenericMediaServer& server);
+    virtual ~ServerMediaSessionIterator();
+    ServerMediaSession* next();
+  private:
+    HashTable::Iterator* fOurIterator;
+  };
+
+protected:
+  friend class ClientConnection;
+  friend class ClientSession;	
+  friend class ServerMediaSessionIterator;
+  int fServerSocket;
+  Port fServerPort;
+  unsigned fReclamationSeconds;
+
+private:
+  HashTable* fServerMediaSessions; // maps 'stream name' strings to "ServerMediaSession" objects
+  HashTable* fClientConnections; // the "ClientConnection" objects that we're using
+  HashTable* fClientSessions; // maps 'session id' strings to "ClientSession" objects
+};
+
+// A data structure used for optional user/password authentication:
+
+class UserAuthenticationDatabase {
+public:
+  UserAuthenticationDatabase(char const* realm = NULL,
+			     Boolean passwordsAreMD5 = False);
+    // If "passwordsAreMD5" is True, then each password stored into, or removed from,
+    // the database is actually the value computed
+    // by md5(<username>:<realm>:<actual-password>)
+  virtual ~UserAuthenticationDatabase();
+
+  virtual void addUserRecord(char const* username, char const* password);
+  virtual void removeUserRecord(char const* username);
+
+  virtual char const* lookupPassword(char const* username);
+      // returns NULL if the user name was not present
+
+  char const* realm() { return fRealm; }
+  Boolean passwordsAreMD5() { return fPasswordsAreMD5; }
+
+protected:
+  HashTable* fTable;
+  char* fRealm;
+  Boolean fPasswordsAreMD5;
+};
+
+#endif
Index: liveMedia/include/H264VideoFileServerMediaSubsession.hh
===================================================================
--- liveMedia/include/H264VideoFileServerMediaSubsession.hh	(revision 14473)
+++ liveMedia/include/H264VideoFileServerMediaSubsession.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _H264_VIDEO_FILE_SERVER_MEDIA_SUBSESSION_HH
 #define _H264_VIDEO_FILE_SERVER_MEDIA_SUBSESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FILE_SERVER_MEDIA_SUBSESSION_HH
 #include "FileServerMediaSubsession.hh"
 #endif
 
-class H264VideoFileServerMediaSubsession: public FileServerMediaSubsession {
+class LIVEMEDIALIB_API H264VideoFileServerMediaSubsession: public FileServerMediaSubsession {
 public:
   static H264VideoFileServerMediaSubsession*
   createNew(UsageEnvironment& env, char const* fileName, Boolean reuseFirstSource);
Index: liveMedia/include/H264VideoFileSink.hh
===================================================================
--- liveMedia/include/H264VideoFileSink.hh	(revision 14473)
+++ liveMedia/include/H264VideoFileSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _H264_VIDEO_FILE_SINK_HH
 #define _H264_VIDEO_FILE_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _H264_OR_5_VIDEO_FILE_SINK_HH
 #include "H264or5VideoFileSink.hh"
 #endif
 
-class H264VideoFileSink: public H264or5VideoFileSink {
+class LIVEMEDIALIB_API H264VideoFileSink: public H264or5VideoFileSink {
 public:
   static H264VideoFileSink* createNew(UsageEnvironment& env, char const* fileName,
 				      char const* sPropParameterSetsStr = NULL,
Index: liveMedia/include/H264VideoRTPSink.hh
===================================================================
--- liveMedia/include/H264VideoRTPSink.hh	(revision 14473)
+++ liveMedia/include/H264VideoRTPSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _H264_VIDEO_RTP_SINK_HH
 #define _H264_VIDEO_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _H264_OR_5_VIDEO_RTP_SINK_HH
 #include "H264or5VideoRTPSink.hh"
 #endif
 
-class H264VideoRTPSink: public H264or5VideoRTPSink {
+class LIVEMEDIALIB_API H264VideoRTPSink: public H264or5VideoRTPSink {
 public:
   static H264VideoRTPSink*
   createNew(UsageEnvironment& env, Groupsock* RTPgs, unsigned char rtpPayloadFormat);
Index: liveMedia/include/H264VideoRTPSource.hh
===================================================================
--- liveMedia/include/H264VideoRTPSource.hh	(revision 14473)
+++ liveMedia/include/H264VideoRTPSource.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _H264_VIDEO_RTP_SOURCE_HH
 #define _H264_VIDEO_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
 
-class H264VideoRTPSource: public MultiFramedRTPSource {
+class LIVEMEDIALIB_API H264VideoRTPSource: public MultiFramedRTPSource {
 public:
   static H264VideoRTPSource*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
@@ -51,7 +57,7 @@
   unsigned char fCurPacketNALUnitType;
 };
 
-class SPropRecord {
+class LIVEMEDIALIB_API SPropRecord {
 public:
   ~SPropRecord() { delete[] sPropBytes; }
 
@@ -59,7 +65,7 @@
   unsigned char* sPropBytes;
 };
 
-SPropRecord* parseSPropParameterSets(char const* sPropParameterSetsStr,
+LIVEMEDIALIB_API SPropRecord* parseSPropParameterSets(char const* sPropParameterSetsStr,
 				     // result parameter:
 				     unsigned& numSPropRecords);
     // Returns the binary value of each 'parameter set' specified in a
Index: liveMedia/include/H264VideoStreamDiscreteFramer.hh
===================================================================
--- liveMedia/include/H264VideoStreamDiscreteFramer.hh	(revision 14473)
+++ liveMedia/include/H264VideoStreamDiscreteFramer.hh	(revision 14474)
@@ -24,11 +24,17 @@
 #ifndef _H264_VIDEO_STREAM_DISCRETE_FRAMER_HH
 #define _H264_VIDEO_STREAM_DISCRETE_FRAMER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _H264_OR_5_VIDEO_STREAM_DISCRETE_FRAMER_HH
 #include "H264or5VideoStreamDiscreteFramer.hh"
 #endif
 
-class H264VideoStreamDiscreteFramer: public H264or5VideoStreamDiscreteFramer {
+class LIVEMEDIALIB_API H264VideoStreamDiscreteFramer: public H264or5VideoStreamDiscreteFramer {
 public:
   static H264VideoStreamDiscreteFramer*
   createNew(UsageEnvironment& env, FramedSource* inputSource);
Index: liveMedia/include/H264VideoStreamFramer.hh
===================================================================
--- liveMedia/include/H264VideoStreamFramer.hh	(revision 14473)
+++ liveMedia/include/H264VideoStreamFramer.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _H264_VIDEO_STREAM_FRAMER_HH
 #define _H264_VIDEO_STREAM_FRAMER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _H264_OR_5_VIDEO_STREAM_FRAMER_HH
 #include "H264or5VideoStreamFramer.hh"
 #endif
 
-class H264VideoStreamFramer: public H264or5VideoStreamFramer {
+class LIVEMEDIALIB_API H264VideoStreamFramer: public H264or5VideoStreamFramer {
 public:
   static H264VideoStreamFramer* createNew(UsageEnvironment& env, FramedSource* inputSource,
 					  Boolean includeStartCodeInOutput = False);
Index: liveMedia/include/H264or5VideoFileSink.hh
===================================================================
--- liveMedia/include/H264or5VideoFileSink.hh	(revision 14473)
+++ liveMedia/include/H264or5VideoFileSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _H264_OR_5_VIDEO_FILE_SINK_HH
 #define _H264_OR_5_VIDEO_FILE_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FILE_SINK_HH
 #include "FileSink.hh"
 #endif
 
-class H264or5VideoFileSink: public FileSink {
+class LIVEMEDIALIB_API H264or5VideoFileSink: public FileSink {
 protected:
   H264or5VideoFileSink(UsageEnvironment& env, FILE* fid,
 		       unsigned bufferSize, char const* perFrameFileNamePrefix,
@@ -38,6 +44,11 @@
 protected: // redefined virtual functions:
   virtual void afterGettingFrame(unsigned frameSize, unsigned numTruncatedBytes, struct timeval presentationTime);
 
+  virtual void writeHeader(unsigned frameSize, struct timeval presentationTime);
+  // IHP: Write out initial file data
+  virtual void writeFrame(unsigned frameSize, unsigned numTruncatedBytes, struct timeval presentationTime);
+  // IHP: Write out the acctual frame (called after any initial file data is written)
+
 private:
   char const* fSPropParameterSetsStr[3];
   Boolean fHaveWrittenFirstFrame;
Index: liveMedia/include/H264or5VideoRTPSink.hh
===================================================================
--- liveMedia/include/H264or5VideoRTPSink.hh	(revision 14473)
+++ liveMedia/include/H264or5VideoRTPSink.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _H264_OR_5_VIDEO_RTP_SINK_HH
 #define _H264_OR_5_VIDEO_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _VIDEO_RTP_SINK_HH
 #include "VideoRTPSink.hh"
 #endif
@@ -28,7 +34,7 @@
 #include "FramedFilter.hh"
 #endif
 
-class H264or5VideoRTPSink: public VideoRTPSink {
+class LIVEMEDIALIB_API H264or5VideoRTPSink: public VideoRTPSink {
 protected:
   H264or5VideoRTPSink(int hNumber, // 264 or 265
 		      UsageEnvironment& env, Groupsock* RTPgs, unsigned char rtpPayloadFormat,
@@ -40,6 +46,9 @@
 
 private: // redefined virtual functions:
   virtual Boolean continuePlaying();
+
+protected:
+  // IHP: Making this protected so we can subclass it
   virtual void doSpecialFrameHandling(unsigned fragmentationOffset,
                                       unsigned char* frameStart,
                                       unsigned numBytesInFrame,
Index: liveMedia/include/InputFile.hh
===================================================================
--- liveMedia/include/InputFile.hh	(revision 14473)
+++ liveMedia/include/InputFile.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _INPUT_FILE_HH
 #define _INPUT_FILE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #include <UsageEnvironment.hh>
 #include <stdio.h>
 
@@ -46,21 +52,21 @@
 #include <sys/stat.h>
 #endif
 
-FILE* OpenInputFile(UsageEnvironment& env, char const* fileName);
+LIVEMEDIALIB_API FILE* OpenInputFile(UsageEnvironment& env, char const* fileName);
 
-void CloseInputFile(FILE* fid);
+LIVEMEDIALIB_API void CloseInputFile(FILE* fid);
 
-u_int64_t GetFileSize(char const* fileName, FILE* fid);
+LIVEMEDIALIB_API u_int64_t GetFileSize(char const* fileName, FILE* fid);
     // 0 means zero-length, unbounded, or unknown
 
-int64_t SeekFile64(FILE *fid, int64_t offset, int whence);
+LIVEMEDIALIB_API int64_t SeekFile64(FILE *fid, int64_t offset, int whence);
     // A platform-independent routine for seeking within (possibly) large files
 
-int64_t TellFile64(FILE *fid);
+LIVEMEDIALIB_API int64_t TellFile64(FILE *fid);
     // A platform-independent routine for reporting the position within
     // (possibly) large files
 
-Boolean FileIsSeekable(FILE *fid);
+LIVEMEDIALIB_API Boolean FileIsSeekable(FILE *fid);
     // Tests whether "fid" is seekable, by trying to seek within it.
 
 #endif
Index: liveMedia/include/JPEGVideoRTPSource.hh
===================================================================
--- liveMedia/include/JPEGVideoRTPSource.hh	(revision 14473)
+++ liveMedia/include/JPEGVideoRTPSource.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _JPEG_VIDEO_RTP_SOURCE_HH
 #define _JPEG_VIDEO_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
@@ -27,7 +33,7 @@
 
 #define MAX_JPEG_HEADER_SIZE 1024
 
-class JPEGVideoRTPSource: public MultiFramedRTPSource {
+class LIVEMEDIALIB_API JPEGVideoRTPSource: public MultiFramedRTPSource {
 public:
   static JPEGVideoRTPSource*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
@@ -38,7 +44,7 @@
 protected:
   virtual ~JPEGVideoRTPSource();
 
-private:
+  // IHP: Moving this to protected so we can subclass
   JPEGVideoRTPSource(UsageEnvironment& env, Groupsock* RTPgs,
 		     unsigned char rtpPayloadFormat,
 		     unsigned rtpTimestampFrequency,
@@ -45,6 +51,7 @@
 		     unsigned defaultWidth, unsigned defaultHeight);
       // called only by createNew()
 
+private:
   // Image dimensions from the SDP description, if any
   unsigned fDefaultWidth, fDefaultHeight;
 
Index: liveMedia/include/MPEG4ESVideoRTPSink.hh
===================================================================
--- liveMedia/include/MPEG4ESVideoRTPSink.hh	(revision 14473)
+++ liveMedia/include/MPEG4ESVideoRTPSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _MPEG4ES_VIDEO_RTP_SINK_HH
 #define _MPEG4ES_VIDEO_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _VIDEO_RTP_SINK_HH
 #include "VideoRTPSink.hh"
 #endif
 
-class MPEG4ESVideoRTPSink: public VideoRTPSink {
+class LIVEMEDIALIB_API MPEG4ESVideoRTPSink: public VideoRTPSink {
 public:
   static MPEG4ESVideoRTPSink* createNew(UsageEnvironment& env,
 					Groupsock* RTPgs, unsigned char rtpPayloadFormat,
Index: liveMedia/include/MPEG4ESVideoRTPSource.hh
===================================================================
--- liveMedia/include/MPEG4ESVideoRTPSource.hh	(revision 14473)
+++ liveMedia/include/MPEG4ESVideoRTPSource.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _MPEG4_ES_VIDEO_RTP_SOURCE_HH
 #define _MPEG4_ES_VIDEO_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
 
-class MPEG4ESVideoRTPSource: public MultiFramedRTPSource {
+class LIVEMEDIALIB_API MPEG4ESVideoRTPSource: public MultiFramedRTPSource {
 public:
   static MPEG4ESVideoRTPSource*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
@@ -35,7 +41,7 @@
 protected:
   virtual ~MPEG4ESVideoRTPSource();
 
-private:
+  // IHP: Moving to protected so we can subclass
   MPEG4ESVideoRTPSource(UsageEnvironment& env, Groupsock* RTPgs,
 			unsigned char rtpPayloadFormat,
 			unsigned rtpTimestampFrequency);
Index: liveMedia/include/MPEG4GenericRTPSink.hh
===================================================================
--- liveMedia/include/MPEG4GenericRTPSink.hh	(revision 14473)
+++ liveMedia/include/MPEG4GenericRTPSink.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _MPEG4_GENERIC_RTP_SINK_HH
 #define _MPEG4_GENERIC_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SINK_HH
 #include "MultiFramedRTPSink.hh"
 #endif
 
-class MPEG4GenericRTPSink: public MultiFramedRTPSink {
+class LIVEMEDIALIB_API MPEG4GenericRTPSink: public MultiFramedRTPSink {
 public:
   static MPEG4GenericRTPSink*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
Index: liveMedia/include/MPEG4GenericRTPSource.hh
===================================================================
--- liveMedia/include/MPEG4GenericRTPSource.hh	(revision 14473)
+++ liveMedia/include/MPEG4GenericRTPSource.hh	(revision 14474)
@@ -20,12 +20,18 @@
 
 #ifndef _MPEG4_GENERIC_RTP_SOURCE_HH
 #define _MPEG4_GENERIC_RTP_SOURCE_HH
+
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
 
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
 
-class MPEG4GenericRTPSource: public MultiFramedRTPSource {
+class LIVEMEDIALIB_API MPEG4GenericRTPSource: public MultiFramedRTPSource {
 public:
   static MPEG4GenericRTPSource*
   createNew(UsageEnvironment& env, Groupsock* RTPgs,
@@ -42,7 +48,7 @@
 protected:
   virtual ~MPEG4GenericRTPSource();
 
-private:
+  // IHP: Moving to protected so we can subclass
   MPEG4GenericRTPSource(UsageEnvironment& env, Groupsock* RTPgs,
 			unsigned char rtpPayloadFormat,
 			unsigned rtpTimestampFrequency,
@@ -75,6 +81,6 @@
 
 // A function that looks up the sampling frequency from an
 // "AudioSpecificConfig" string.  (0 means 'unknown')
-unsigned samplingFrequencyFromAudioSpecificConfig(char const* configStr);
+LIVEMEDIALIB_API unsigned samplingFrequencyFromAudioSpecificConfig(char const* configStr);
 
 #endif
